document.onselectstart = function(){return false;};
jQuery.fn.powerTbl = function() {

	/**
	 * Initial Volun table
	 */
	var layout = null;		//輸出畫面
	var voluns = [];		//志願列表
	var tmpVoluns = [];		//暫存志願列表
	var info   = [];
	var target = "voluns";  //設定志願新增的目標
	var dragable = false;   //是否可以拖拉
	var errCode = {
		"-1":"已達100個志願，超過校系志願不會被加入。",
		"-2":"校系代碼格式錯誤",
		"-3":"以下志願代碼",
		"-4":"以下志願重複",
		"-5":"以下志願因系組停招故無法登記"
	};
	var err    = {};        //錯誤訊息
	var skillErro = 0;      //術科錯誤成績       
	/**
	 * Function List
	 */
	//顯示志願
	this.render = function(){
		//清除table裡面的資料
		this.empty();
		var out = $('<ul class="vContener"></ul>');
		var counter = 1;
		var nOfRow = 0;//變橫向Row column 參數計算方式改變

		for(var i in voluns){
			var info = this.getCanInfo(voluns[i]);
			var str  = '';
			
			//系所名稱太長需要顯示 ...
			var deptNa   = (info[DEPT_NAME].length > 17)?info[DEPT_NAME].substring(0,17)+'...':info[DEPT_NAME]; 
			var schoolID = info[SCHOOL_ID];
			str += counter+'.';
			str += '﹝'+info[CAN_ID]+'﹞';              //can_id
			str += school_array[schoolID]+'<br/>';     //學校名稱
			str += deptNa;                             //系所名稱
			
			//RowNumber
			var modeNumber = (counter % 4);
			var nOfColumn     = (i % 4);
			var rowIndex   = 'v'+nOfColumn+nOfRow;
			//驗證志願是否符合條件
			if(this.validate(info)){
				out.append('<li class="vNode vValid '+rowIndex+'" name="'+info[CAN_ID]+'">'+str+'</li>');
			}else{
				out.append('<li class="vNode vInvalid '+rowIndex+'" name="'+info[CAN_ID]+'">'+str+'</li>');
			}

			//做分列
			if(modeNumber == 0){
				this.append(out);
				out = $('<ul class="vContener"></ul>');
				nOfRow++;
			}
			counter++;
		}
		if(out.html() != '') this.append(out);
		$(".vContener:even li").addClass('nodeeven');
		$(".vContener:odd li").addClass('nodeodd');
		//hook
		this.afterRender();
		
		//點選志願
		var vTable = this;
		$('.vNode').unbind();
		$('.vNode').click(function(event){
			//顯示該志願狀態
			var canId = $(this).attr('name');
			var offset = $(this).offset();
			var info = volunTab.showCanInfo(canId);
			//2011-04-27 將學系資訊下移26px->34px by leomax
			var top  = (offset.top > 650)? (offset.top -152) :offset.top+34;
			$('#showVolInfo').css('top',top);
			$('#showVolInfo').css('left',offset.left);
			$('#showVolInfo').empty();
			$('#showVolInfo').append(info);
			//2020-07-19 如果校系明細的高度超過169，就把top的位置再往上移34
			if($('#showVolInfo').height() >= 169 && offset.top > 650){
				//top  = offset.top -186;
				top  = offset.top - 212;
				$('#showVolInfo').css('top',top);
			}
			//2022-05-16 如果校系明細的高度超過244，就把top的位置再往上移
			if($('#showVolInfo').height() >= 240 && offset.top > 650){
				top  = offset.top - $('#showVolInfo').height();
				$('#showVolInfo').css('top',top);
			}
			$('#showVolInfo').show();
		}).dblclick(function(){
			//2011-04-28 完成選填志願後 不能刪除志願
			if(!dragable) return false;
			
			//隱藏系所資訊
			$('#showVolInfo').hide();
			
			//顯示警告訊息
			var ctx = $(this).clone();
			$('br',ctx).remove();
			context = ctx.html();
			
			var matches = context.match('([0-9]{1,})\.(.{1,})');
			var isRemove = confirm("是否刪除第"+matches[1]+"志願"+matches[2]);
			if(!isRemove) return false;
			
			//刪除該志願
			var canId = $(this).attr('name');
			var buffer = [];
			for(var i in voluns){
				if(voluns[i] == canId) continue;
				buffer.push(voluns[i]);
			}
			voluns = buffer;
			vTable.render();
			
			//enable button
			vTable.unlock_choice_menu();
			vTable.unlock();
		}).mouseover(function(event){
			$(this).addClass('vfocus');
		}).mouseleave(function(){
			$(this).removeClass('vfocus');
			$('#showVolInfo').hide();
		}).mousedown(function(event){
			//if cannot drag
			if(!dragable) return false;
			
			//init drag
			var target = $(this);
			var isDrag = false;
			
			/**
			 * 取得V01的位置來計算目前要highlight哪一個Node
			 */
			var offset   = $('.v00').offset();
			var offsetX  = $('.v10').offset();
			var offsetY  = $('.v01').offset();
			
			try{
				var gapX = (offsetX.left - offset.left);
			}catch(e){
				var gapX = 190;
			}
			
			try{
				var gapY = (offsetY.top  - offset.top);
			}catch(e){
				var gapY = 36;
			}
			
			
			$('#cloneVolDIV').empty();
			$('#cloneVolDIV').append($(this).html());
			$('#cloneVolDIV').css('width',$(this).width());
			$('#cloneVolDIV').css('top',event.pageY-(gapY/2));
			$('#cloneVolDIV').css('left',event.pageX-(gapX/2));
			$('#cloneVolDIV').focus();
			
			$(document).mousemove(function(evt){
				//drag start
				isDrag = true;
				
				var userX = evt.pageX - (gapX/2);
				var userY = evt.pageY - (gapY/2);				
				var vRowPos = ((userY - offset.top  )/gapY);
				var vColPos = ((userX - offset.left )/gapX);
				
				//set clone layer
				$('#cloneVolDIV').css('top',userY);
				$('#cloneVolDIV').css('left',userX);
				$('#cloneVolDIV').show();
				
				var vRowIdx = Math.round(vRowPos);
				var vColIdx = Math.round(vColPos);
				$('.vfocus').removeClass('vfocus');
				$('.v'+vColIdx+vRowIdx).addClass('vfocus');
				return false;
			}).mouseup(function(evt){
				//if drag start, drop
				if(isDrag){
					var dst = $('.vfocus').text();
					var toRank = dst.match('^[0-9]{1,}');
					
					//XXX 檢查是否有選擇交換項目
					if(toRank !== null){
						var to = toRank[0] - 1;
						var src = $('#cloneVolDIV').text();
						var fromRank = src.match('^[0-9]{1,}');
						var from = fromRank[0] - 1;
						
						//交換
						vTable.exchange(from,to);
						vTable.render();
					}
					//還原
					$('#cloneVolDIV').hide();
				}
				$(document).unbind();
				isDrag = false;
			});			
		});
		//已挑選志願數量顯示
		if($(".vNode").length<100){
			$("#selevolinfo").html("<span style='color:#BB5500'>您已選 "+$(".vNode").length+" 個志願</span>");
		}else{
			$("#selevolinfo").html("<span style='color:red'>已達100志願，若要繼續新增，請先刪除部分已選志願</span>");
		}
	};
	
	//滑鼠移動到某個志願時,highlight他。
	this.highlightNode = function(x,y){
	};
	
	this.setVersion = function(v){
		version = v;
	};
	
	this.enableDrag = function(){
		dragable = true;
	};
	
	//serialize
	this.serialize = function(){
		var buffer = '';
		for(var i in voluns){
			buffer += voluns[i];
		}
		return buffer;
	};
	
	//hook after render table
	this.afterRender = function(){};
	
	/**
	 * Get cookie
	 */
	function getCookie(c_name){
		if (document.cookie.length>0){
			c_start=document.cookie.indexOf(c_name + "=");
			if (c_start!=-1){
				c_start=c_start + c_name.length+1;
				c_end=document.cookie.indexOf(";",c_start);
		    	if (c_end==-1) c_end=document.cookie.length;
		    	return unescape(document.cookie.substring(c_start,c_end));
			}
		}
		return "";
	}
	
	//驗證志願資格是否相符
	//@return boolean
	this.validate = function(info){
		var msg = '';
		
		//檢查性別
		if(info[SEX] != "0"){
			if(sex != info[SEX]) return false;
		}
		
		//檢查學測級分
		let is_math_aorb = !!((info[BASIC_LEVEL].substr(4, 2) - 0) && (info[BASIC_LEVEL].substr(6, 2) - 0));

		for(var i = 0; i < info[BASIC_LEVEL].length ; i+=2 ){
			var idx = i/2;
			var a = info[BASIC_LEVEL].substr(i, 2) - 0;
			var b = score.cScore[idx]?score.cScore[idx]:0;
			//if(a > b) return false; //20190722 mark
			//20190722 add

			if(idx != 6){ //20190409 不顯示總級分

				// 20220328 加上判斷數學A 或數學B 擇一 by Lydia
				if((is_math_aorb) && (idx == 2 || idx == 3) ) {
					if(idx == 2) {
						//數學B
						let i2 = i+2;
						let idx2 = i2/2;
						let a2 = info[BASIC_LEVEL].substr(i2, 2) - 0;
						let b2 = score.cScore[idx2]?score.cScore[idx2]:0;

						if ((a > 0 && b == '--') || (a > 0 && a > b)){  
							// 數學A沒過，檢查數學B
							if ((a2 > 0 && b2 == '--') || (a2 > 0 && a2 > b2)){  
								// 數學B也沒過
								return false;
							} 
						} 
					} else {
						continue;
					}
				} else {

					if ((a > 0 && b == '--') || (a > 0 && a > b)){  //有採計但未報考 or 或 有採計但分數不及 以紅字顯示 
						return false;
					} 
				}
			}
		}

		//檢查考試科目:系所要求但是我沒考
		//@REFERENCE:https://developer.mozilla.org/En/Core_JavaScript_1.5_Reference/Operators/Bitwise_Operators
        if(~( examCount & info[EXAM_GROUP] ) & info[EXAM_GROUP]){
            return false;
        }
        
		//檢查術科分數
		var skillScore = this.getSkillScore(info);
		if(skillScore < 0) return false;
		
		//是否未加權總分高於最低登記標準
		var mscore = info[MESCORE] - 0;
		var oriScore = this.getMescore(info);   //考生未加權成績
		
		if(!isNaN(oriScore)){
			var gap = mscore - oriScore;
			if( gap > 0) return false;
		} else {
			return false;
		}
		
		//103年度新增: 考生身份為專家但校系不接受專家
		if(expert=='2' && info[EXPERT]!='2'){
			return false;
		}

		//104年度新增: 校系有要求英檢　且　考生等級低於英檢要求等級
		//一般生
		if(listen_basic=='1'){			
			if(info[LISTEN]!='0' && (listen_score=='*' || listen_score=='-' || listen_score > info[LISTEN] )){
				return false;
			}
		}
		
		//20190403 108年度新增:「限原住民」篩檢：遇限原住民校系時，校系條件出現限原住民字樣，且如考生非原住民該系組以紅字顯示。
		if(info[SPECIAL_LIMIT] =='2'){
			 
		 	if(id_type_ok != '4' && id_type_ok != '8'){		
				return false;
			}					 			
		}
		return true;
	};
	
	this.serializeScore = function(){
		var output = '';
		for(var i in score){
			output = output + i +':';
			for(var j in score[i]){
				output += score[i][j]+',';
			}
			output = output + '<br/>';
		}
		$("body").prepend(output);
	};
	
	this.showCanInfo = function(canId){
		var info = this.getCanInfo(canId);
		var output = $('<div class="canInfo"></div>');

		//1.性別
		var buffer = "1.性別:";
		var reqSex = info[SEX];
		if(reqSex != "0"){
			if(sex != reqSex){
				buffer += '<span class="vInvalid">'+GENDER[reqSex]+'</span>';
			} else {
				buffer += '<span>'+GENDER[reqSex]+'</span>';
			}
		} else {
			buffer += '<span>'+GENDER[reqSex]+'</span>';
		}
		var buffer = '<div class="dHeader">'+buffer+'</div>';
		output.append(buffer);
		
		//2.學測  (111 改為檢定-學測) by Lydia
		buffer = '';
		output.append("<div class='dHeader'>2.檢定-學測:</div>");

		//20220328 先判斷數學A和數學B是不是擇一即可 by Lydia
		let is_math_aorb = !!((info[BASIC_LEVEL].substr(4, 2) - 0) && (info[BASIC_LEVEL].substr(6, 2) - 0));

		for(var i = 0; i < info[BASIC_LEVEL].length ; i+=2 ){
			var idx = i/2;
			var a = info[BASIC_LEVEL].substr(i, 2) - 0;
		    var b = score.cScore[idx]?score.cScore[idx]:0;
			var reqcScore = (a > 0)?a:"不限";

			 //if(a > b){
			 //	buffer += '<span class="vInvalid">'+STRING_TABLE_BASIC[idx]+'*'+reqcScore+'*'+b+' </span>';
			//}else 
			if(idx != STRING_TABLE_BASIC.length){ //20190409 不顯示總級分

				// 20220328 數學A或數學B擇一的時候拉出來判斷 by Lydia
				if((is_math_aorb) && (idx == 2 || idx == 3) ) {

					if(idx == 2) {

						//數學B
						let i2 = i+2;
						let idx2 = i2/2;
						let a2 = info[BASIC_LEVEL].substr(i2, 2) - 0;
						let b2 = score.cScore[idx2]?score.cScore[idx2]:0;
						let reqcScore2 = (a2 > 0)?a2:"不限";

						buffer += '\<'+STRING_TABLE_BASIC[idx]+':'+reqcScore+' 或 '+STRING_TABLE_BASIC[idx2]+':'+reqcScore2 + ' \>';
						

						if ((a > 0 && b == '--') || (a > 0 && a > b)){  
							// 數學A沒過，檢查數學B
							if ((a2 > 0 && b2 == '--') || (a2 > 0 && a2 > b2)){  
								// 數學B也沒過，顯示紅字
								buffer = '<p class="vInvalid">' + buffer + '</p>';
							} else {
								// 數學B通過
								buffer = '<p>' + buffer + '</p>';
							}
						} else {
							// 數學A通過
							buffer = '<p>' + buffer + '</p>';
						}

						output.append('<div class="dBody">'+buffer+'</div>');
						buffer = '';
						
					} else {
						continue;
					}

				} else {

					if ((a > 0 && b == '--') || (a > 0 && a > b)){  
						//有採計但未報考的科目以紅字顯示 或 有採計但分數不及的以紅字顯示
						buffer += '<p class="vInvalid">\<'+STRING_TABLE_BASIC[idx]+':'+reqcScore+'\> </p>';
					} else {
						buffer += '<p>\<'+STRING_TABLE_BASIC[idx]+':'+reqcScore+' \></p>';
					}
					
					//國.英.數/社.自.總
					//if((idx % 3) == 2){
						output.append('<div class="dBody">'+buffer+'</div>');
						buffer = '';
				//}
				}
			}
		}
		//7.英檢			
		//104年度新增: 校系有要求英檢　且　考生等級低於英檢要求等級		
		//不限
		
		if(info[LISTEN]=='0')
		{
			output.append("<div class='dHeader'>3.檢定-英聽:不限</div>");	
		}
		//有限
		else{

			//聽障生
			if(listen_basic=='2'){
				output.append("<div class='dHeader'>3.檢定-英聽:"+info[LISTEN]+"級</div>");
			}
			//一般生
			else{
				//不符合條件			
				if(listen_score=='*' || listen_score=='-' || listen_score > info[LISTEN] ){
					output.append("<div class='dHeader'>3.檢定-英聽:<span class='vInvalid'>"+info[LISTEN]+"級</span></div>");
			     
				}
				//符合條件
				else{
					output.append("<div class='dHeader'>3.檢定-英聽:"+info[LISTEN]+"級</div>");
				}
			}
		}		

		//3.分科測驗 (111 文字改為採計，且加入學測與術科) by Lydia
		buffer = '';
		output.append('<div class="dHeader">4.採計:</div>');

		// var a = info[BASIC_LEVEL].substr(i, 2) - 0;

		// 2022328 改為讀取同分參酌順序 by Lydia
		for(var j = 0; j < info[ONSAME].length ; j++){

			let k = info[ONSAME].substr(j, 1);

			if(k == 0) {
				continue;
			}

			let i = STRING_TABLE_ONSAME[k];

			//for(var i in STRING_TABLE_EXAM){

			// 術科另外判斷
			if(i == 11) {
				// 10 音樂 11 美術 12 體育
				for(art = 10; art <= 12; art++) {
					var s = Math.pow(2, art);
					var isRequired = (s & info[EXAM_GROUP]);
					var isTested   = (s & examCount);

					if(isRequired) {
						if(isTested) {
							buffer += '<span>'+STRING_TABLE_EXAM[art]+' </span>';
						} else {
							buffer += '<span class="vInvalid">'+STRING_TABLE_EXAM[art]+' </span>';
						}
					}
				}

			} else {
				var s = Math.pow(2, i);
				var isRequired = (s & info[EXAM_GROUP]);
				var isTested   = (s & examCount);

				if(isRequired) {
					if(isTested) {
						buffer += '<span>'+STRING_TABLE_EXAM[i]+' </span>';
					} else {
						buffer += '<span class="vInvalid">'+STRING_TABLE_EXAM[i]+' </span>';
					}
				}
			} 

		}
		output.append('<div class="dBody">'+buffer+'</div>');
        
		//4.1 術科
		var chapter = 4;
		var skillType = info[SKILL_TY] - 0;
		var skillScore = this.getSkillScore(info);
		var ratio = info[R_ART];
		
		//有採計術科才進入術科條件限選
		if(skillType > 0){
			chapter++;
			switch(skillScore){
				case -1:
					//採計的科目沒有考,術科成績算0分
				//	alert(1);
					var str = this.showSkillunSign(info);
					output.append("<div class='dHeader'>5.術科:</div><div class='vInvalid dBody'>"+str+'</div>');
					break;
				case -2:
				//	alert(2);
					//術科任意小項不得為0
					var str = this.showSillunZero(info);
					output.append("<div class='dHeader'>5.術科:</div><div class='vInvalid dBody'>"+str+'</div>');
					break;
				case -3:
					//術科最低分數
					output.append("<div class='dHeader'>5.術科最低分數:"+info[SKILL_LOW_SC]+'</div>');
					output.append("<div class='vInvalid dBody'>考生術科分數:"+skillErro+'</div>');
					break;
				default:
					//術科最低分數/考生術科分數
					var s = (info[SKILL_LOW_SC] > 0 )?info[SKILL_LOW_SC]:"不限";
					output.append("<div class='dHeader'>5.術科最低分數:"+ s +'</div>');
					output.append("<div class='dBody'>考生術科分數:"+skillScore+'</div>');
					break;
			}
		}
			
		//6.最低登記標準
		chapter++;
		var unWeightScore = this.getMescore(info);
		var mscore = info[MESCORE] - 0;
		// 20190502 最低登記標準設0
		// 2019/5/7的版本還不用抓mescore，7/18才會更新今年的標準上去
		// 2019/5/2 要執行create_practice.php, 7/18執行create_single.php 
		var gap = mscore - unWeightScore;
		output.append('<div class="dHeader">'+chapter+".最低登記標準:"+mscore+'分</div>');
		
		if(isNaN(gap)){
			output.append("<div class='vInvalid dBody'>考生未加權成績: ---- </div>");
		}else if( gap > 0){
			output.append("<div class='vInvalid dBody' >考生未加權成績:"+unWeightScore+"分</div>");
		} else {
			output.append("<div class='dBody'>考生未加權成績:"+unWeightScore+"分</div>");
		}
		
		//chapter++;
		//7.103年度新增:專家資格審查		
		if(expert=='2' && info[EXPERT]!='2'){
			chapter++;
			output.append("<div class='dHeader'>"+chapter+".學力證明文件審查:</div><div class='vInvalid dBody'>本系組不受理「分發入學學力資格」第18款報名之考生</div>");
			
		}
		//6.計算加權總分
		//output.append('<dt>5.最低入學標準:</dt>');
		//var weightedScore = this.getWeightScore(info);
		//output.append('<div class="dBody">考生加權總分:'+weightedScore+'分</div>');
		
		
		//8.108年度新增:「限原住民」篩檢：遇限原住民校系時，校系條件出現限原住民字樣，且如考生非原住民該系組以紅字顯示。	//20190403			
		if(info[SPECIAL_LIMIT] =='2' ){				 
			chapter++;	
			//校系限制: 1:一般校系 2:限原住民校系	
			if(id_type_ok == '4' || id_type_ok == '8'){
				//原住民
				output.append("<div class='dHeader'>"+chapter+".限原住民:是</div><div class='dBody'>身份符合</div>");	
			}else{
				//其它生
				output.append("<div class='dHeader'>"+chapter+".限原住民:是</div><div class='vInvalid dBody'>身份不符</div>");			
			} 
		} 		
		return output;
	};
	
	//計算加權總分 : (111學年筆記: 聽說現在沒再用這塊了)
	this.getWeightScore = function(info){
		var sSco = score.sScore;
		var totScore = 0;
		var wScore  = 0; //加權總分
		var sflavor = 0; //優待分數
		var mescore = info[MESCORE] - 0;
		var weight  = info[EXAM_CNT];
		var wlen    = (weight.length - 1);
		
		//國文+ ....+公民 共10科 0~9
		for(var i = 0; i< wlen ; i++){
			//fix up : ie6,ie7看不懂 weight[i] = weight.charAt(i)
			if(weight.charAt(i) == 0) continue;
			
			//如果有沒有考的考科,則不計算分數
			if(!isNaN(sSco[i])){
				var w = (1 + (weight.charAt(i) -1) * 0.25);
				wScore += sSco[i]*w;
			} else {
				return '----';
			}
		}
		
		//術科有採計,算術科
		if(weight[wlen] > 0){
			var skillScore = this.getSkillScore(info);
			var sw = (1 + (weight[wlen] -1) * 0.25);
			
			skillScore = (skillScore - 0)*sw;
			wScore += (skillScore > 0)? skillScore: 0;
		}
		
		//加權總分
		wScore = wScore.round(2);
		wScore = wScore -0;
		
		//優待分數
		var sflavor = this.getMescore(info,true);
		sflavor = sflavor - 0;
		
		totScore = (wScore + sflavor);  
		return totScore.round(2);		
	};
	
	//顯示術科不得為0分的科目
	this.showSillunZero = function(info){
		var skillType = info[SKILL_TY] - 0;
		var iSkill = skillType -1;
		var subjectScore = score.tScore[iSkill];
		var output = '';
		var noexam='';
		var scorezero='';
		switch(skillType){
			case 1:
				//音樂
				var ratio = info[R_MUSIC];
				for(var i=0;i<ratio.length;i+=3){
					var v = ratio.slice(i,i+3) - 0;
					//沒有採計就算了
					if(v == 0) continue;
					
					var idx = i/3;
					
					//採計的科目沒有考,或考0,術科成績算0分
					if(isNaN(subjectScore[idx])){
						//沒有考音樂
						if(noexam ==''){
							noexam += " "+MUSIC_EXAM_SUBJECT[idx];
						}else{
							noexam =noexam + '/' + MUSIC_EXAM_SUBJECT[idx];
						}
					} else if((v * subjectScore[idx]) == 0){
						if(scorezero==''){
							scorezero += " "+MUSIC_EXAM_SUBJECT[idx];
						}else{
							scorezero += ','+MUSIC_EXAM_SUBJECT[idx];
						}
					}
				}
				if(scorezero!=''){
					scorezero += " : 不得為0分<br/>";
				}	
				if(noexam!=''){
					noexam += " : 未報考";
				}				
				output += scorezero+noexam;
				break;
			case 2:
				//美術
				var ratio = info[R_ART];
				for(var i=0;i<ratio.length;i+=3){
					var v = ratio.slice(i,i+3) - 0;
					//沒有採計就算了
					if(v == 0) continue;
					
					var idx = i/3;
					//採計的科目沒有考,術科成績算0分
					
					if(isNaN(subjectScore[idx])){
						if(noexam ==''){
							noexam += ART_EXAM_SUBJECT[idx];
						}else{
							noexam += '/'+ART_EXAM_SUBJECT[idx];
						}
						//沒有考美術						
					} else if((v * subjectScore[idx]) == 0){
						if(scorezero==''){
							scorezero += ART_EXAM_SUBJECT[idx];
						}else{
							scorezero += ','+ART_EXAM_SUBJECT[idx];
						}					
					}
				}
				if(scorezero!=''){
					scorezero += " : 不得為0分<br/>";
				}	
				if(noexam!=''){
					noexam += " : 未報考";
				}				
				output += scorezero+noexam;
				break;
			default:
				break;
		}
		return output;
	};
	
	//顯示術科未報考科目
	this.showSkillunSign = function(info){
		var skillType = info[SKILL_TY] - 0;
		var iSkill = skillType -1;
		var subjectScore = score.tScore[iSkill];
		var output = '';
		switch(skillType){
			case 1:
				//音樂
				var ratio = info[R_MUSIC];
				for(var i=0;i<ratio.length;i+=3){
					var v = ratio.slice(i,i+3) - 0;
					//沒有採計就算了
					if(v == 0) continue;
					
					var idx = i/3;
					
					//採計的科目沒有考,術科成績算0分				
					if(!subjectScore){
						//沒有考音樂					
						output += MUSIC_EXAM_SUBJECT[idx]+',';
					} else if(isNaN(subjectScore[idx])){					
						if(output==''){
							output += MUSIC_EXAM_SUBJECT[idx];
						}else{
							output +='/'+MUSIC_EXAM_SUBJECT[idx];
						}
						
					}
				}
				output += " : 未報考";
				break;
			case 2:
				//美術
				var ratio = info[R_ART];
				for(var i=0;i<ratio.length;i+=3){
					var v = ratio.slice(i,i+3) - 0;
					//沒有採計就算了
					if(v == 0) continue;
					
					var idx = i/3;
					
					//採計的科目沒有考,術科成績算0分
					if(!subjectScore){
						//沒有考美術
						output += ART_EXAM_SUBJECT[idx]+',';
					} else if(isNaN(subjectScore[idx])){
						if(output==''){
							output += ART_EXAM_SUBJECT[idx];
						}else{
							output += '/'+ART_EXAM_SUBJECT[idx];
						}
					}					
				}
				output += " : 未報考";
				break;
			case 3:
				output += "體育未報考";
				break;
			default:
				break;
		}
		return output;
	};
	
	//計算原始總分
	this.getMescore = function(info,isfavor){
		var sSco = score.sScore;
		var cScore_sixty = score.cScore_sixty;
		var totScore = 0;
		var mescore = info[MESCORE] - 0;
		var weight  = info[EXAM_CNT];
		var wlen    = weight.length;
		var skillType = info[SKILL_TY] - 0;

		//國文+ ....+公民 0~9 共10項，10術科，11~15 學測分數 weight.length = 17 by Lydia
		for(var i = 0; i<= wlen ; ++i){
			//fix up : ie6,ie7看不懂 weight[i] = weight.charAt(i)
			if(weight.charAt(i) == 0) continue;

			//分別讀取 0~9 分科測驗，10術科，11~15 學測分數 by Lydia
			if(i < 10) {
				//分科測驗
				//如果有沒有考的考科,則不計算分數
				if(!isNaN(sSco[i])){
					totScore += sSco[i];
				} else {
					return '----';
				}
			} else if(i == 10) {
				let skillScore = this.getSkillScore(info);
				if(skillScore < 0) {
					return '----';
				}
			} else if(i <= 17) {
				//學測分數
				//如果有沒有考的考科,則不計算分數
				if(!isNaN(cScore_sixty[i-11])){
					totScore += cScore_sixty[i-11];
				} else {
					return '----';
				}
			}
		}

		//優待分數
		if(isfavor){
			totScore = totScore*favor;
			return totScore.round(2,2); // 改成小數點兩位數 by Lydia
		}

		//術科有採計,算術科 by Lydia
		if(weight[10] > 0){
			var skillScore = this.getSkillScore(info);
			skillScore = (skillScore - 0);
			totScore += (skillScore > 0)? skillScore: 0;
		}
		totScore = totScore - 0;

		return totScore.round(2,2); // 改成小數點兩位數 by Lydia
	};
	
	//計算術科分數
	this.getSkillScore = function(info){
		var skillType = info[SKILL_TY] - 0;

		if(skillType == 0) return 0;
		
		var iSkill = skillType -1;
		var subjectScore = score.tScore[iSkill];
		var skillScore = 0;
		
		//沒考術科就結束
		if(skillType != 3){
			if(subjectScore == undefined) return -1;
		}
		
		switch(skillType){
			case 1:
				//音樂
				var ratio = info[R_MUSIC];
				for(var i=0;i<ratio.length;i+=3){
					var v = ratio.slice(i,i+3) - 0;
					
					//沒有採計就算了
					if(v == 0) continue;
					
					var idx = i/3;
					
										
					//不能考0分的,考零分。總分變零分
					var canZero  = (info[ZERO_SKILL] - 0);
					var hasScore = (subjectScore[idx])? 1:0;
					if(canZero & ~hasScore) return -2;
					
					
					//採計的科目沒有考,術科成績算0分
					if(isNaN(subjectScore[idx])) return -1;
					
					skillScore += subjectScore[idx] * v / 100;
				}
				
				//術科原始總分不得低於xx分
				var s = skillScore.round(2);
				if( info[SKILL_LOW_SC] - s > 0){
					skillErro = s;
					return -3;
				}

				return skillScore.round(2);
				break;
			case 2:
				//美術
				var ratio = info[R_ART];
				for(var i=0;i<ratio.length;i+=3){
					var v = ratio.slice(i,i+3) - 0;
					
					//沒有採計就算了
					if(v == 0) continue;
					
					var idx = i/3;
					//採計的科目沒有考,術科成績算0分
					
					
					//不能考0分的,考零分。總分變零分
					var hasScore = (subjectScore[idx])? 1:0;
					var canZero  = (info[ZERO_SKILL] - 0);
					if(canZero & ~hasScore) return -2;
					
					if(isNaN(subjectScore[idx])) return -1;
					
					skillScore += subjectScore[idx] * v / 100;					
				}

				//術科原始總分不得低於xx分
				var s = skillScore.round(2);
				if( info[SKILL_LOW_SC] - s > 0){
					skillErro = s;
					return -3;
				}
				
				return skillScore.round(2);
				break;
			case 3:
				//體育沒有考,術科成績算0分
				if(isNaN(subjectScore[0])){
					subjectScore = {0:0};
				}
				
				//不能考0分的,考零分。總分變零分
				if(info[19] & ~subjectScore[0]) return -2;
				
				//術科總分不得低於xx分(skill_lowscore)
				var s = subjectScore[0].round(2);
				if( info[SKILL_LOW_SC] - s > 0){
					skillErro = s;
					return -3;
				}
				
				return subjectScore[0];
				break;
			default:
				return 0;
				break;
		}
	};
	
	//取得志願的index
	this.get = function(code){
		var t = _getTarget();
		for(var i in t){
			if(t[i] != code) continue;
			return i;
		}
		return -1;
	};
	
	//batch新增志願
	this.batchAdd = function(v,append,replace){
		this.clearError();

		//先寫入暫存檔
		if(append !== true){
			_setTarget('tmpVoluns'); //置換模式
		}
		
		t = _getTarget();
		
		//要全部新增完成都沒有錯誤,才能更新至voluns
		var result = 1;
		for(var i = 0; i< v.length ;i+=4){
			var vCode = v.slice(i,i+4);
			//1 * 0 = 0
			result = result & this.add(vCode);
		}
		
		//善後處理
		if(append === true){
			return true;
		}else if((result > 0) || replace ){
			//更新志願
			_replaceNew();
			this.unlock();
		} else {
			_restore();
		}
		return true;
	};
	
	//增加一個志願
	this.addOne = function(code){
		this.clearError();
		return this.add(code);
	};

    this.unlock = function(){
        if(voluns.length == 0){
            //enable buttons
			lock_finlock();
			lock_savevol();
        } else {
			//enable buttons
			unlock_finlock();
			unlock_savevol();
		}    
    };
	
	//新增志願
	this.add = function(code){
		
		//get working volun list
		var t = _getTarget();
		
		//檢查是否已達100個志願
		if(t.length >= 100){
			err['-1'] = '';
			return false;
		}
		
		//檢查志願格式是否錯誤
		var matches = code.match(/^[0-7]{4}$/);
		if(matches === null){
			if(err['-3'] == undefined){
				err['-3'] = '\n\t['+code+"]不存在";
			} else {
				err['-3'] += '\n\t['+code+"]不存在";
			}
			return false;
		}
		
		//檢查志願代號是否存在
		var info = this.getCanInfo(code);
		
		if(info == null){
			if(err['-3'] == undefined){
				err['-3'] = '\n\t['+code+"]不存在";
			} else {
				err['-3'] += '\n\t['+code+"]不存在";
			}
			return false;
		}
		var schoolID = info[SCHOOL_ID];
		var schoolNa = school_array[schoolID];
		var deptNa   = info[DEPT_NAME];
		//檢查志願是否重複
		var isExist = this.get(code);
		if(isExist >= 0){
			if(err['-4'] == undefined){
				err['-4'] = '\n\t['+code+']'+schoolNa+'-'+deptNa;
			} else {
				err['-4'] += '\n\t['+code+']'+schoolNa+'-'+deptNa;
			}
			return false;
		}
		
		//檢查該校系核定名額是否為0 2011/04/13 決定練習版不做判斷,因仍可能有回流名額
		var hasQuota = (info[21] -0)?true:false;
		var isPractice = (version == 'practice') ;
		if(!hasQuota && !isPractice){
			if(err['-5'] == undefined){
				err['-5'] = '\n\t['+code+']'+schoolNa+'-'+deptNa;
			} else {
				err['-5'] += '\n\t['+code+']'+schoolNa+'-'+deptNa;
			}
			return false;			
		}
		
		//新增志願
		t.push(code);
		
		//enable button
		unlock_savevol();
		unlock_finlock();
		
		//已達100個志願
		if(t.length >= 100){
			this.lock_choice_menu();
		} else {
			this.unlock_choice_menu();
		}
		
		return true;
	};
	
	function lock_finlock(){
		if(version == 'web'){
			$("#main").tabs( "option", "disabled", [1] );
		}
	}
	
	function unlock_finlock(){
		$("#main").tabs( "option", "disabled", [] );
	}
	
	function lock_savevol(){
		$("#saveVol").button("disable");
	}
	
	function unlock_savevol(){
		$("#saveVol").button("enable");
	}
	
	/***********************************
	 *    disable 選填志願選單
	 **********************************/
	this.lock_choice_menu = function(){
//		alert('指定三科至少勾選三科');
		$("#school_dept_info").button( "disable" );
		$("#select_vol").button( "disable" );
		$("#add_one_vol").button( "disable" );
	};
	
	/***********************************
	 *    enable 選填志願選單
	 **********************************/
	this.unlock_choice_menu = function(){
		$("#school_dept_info").button( "enable" );
		$("#select_vol").button( "enable" );
		$("#add_one_vol").button( "enable" );
	};
	
	//FIXME 這個function要搬家(因為他不太適合放在這裡)
	//建立Filter Patten for 依條件選志願
	this.createFilter = function(){
		$('#pattern_entries').empty();

		let has_pattern = false;

		for(var i in filter_pattern_array){
			//不是(我沒考的 而且 系所有要求)
			if(!(filter_pattern_array[i] & ~examCount )){
				var subjectNa = '';
				for(var j in STRING_TABLE_EXAM ){
					var isCounted = (filter_pattern_array[i] & Math.pow(2,j));
					if(isCounted){
						subjectNa += STRING_TABLE_EXAM[j]+' ';
					}
				}
				has_pattern = true;
				$('#pattern_entries').append("<li><label><input type='checkbox' name='mixture' class='sub_pattern' value='"+filter_pattern_array[i]+"' />"+subjectNa+'</label></li>');
	        }
		}

		// 20220325 若沒有符合的條件，則顯示紅字以及將科目過濾按鈕鎖定 by Lydia
		if(has_pattern) {
			$('#partial_subject').removeAttr('disabled');
			$('#pattern_select_all').removeAttr('disabled');
		} else {
			$('#partial_subject').attr('disabled','disabled');
			$('#pattern_select_all').attr('disabled','disabled');
			$('#pattern_entries').append('<p style="color: red;">無可選擇之組合，欲使用此篩選請重新設定報考科目</p>');
		}
		
		//全部選取
		$('#pattern_select_all').click(function(){
			var isChecked = $(this).attr('checked');
			if(isChecked){
				$('.sub_pattern').attr('checked','checked');
			} else {
				$('.sub_pattern').removeAttr('checked');
			}
		});
		
		
	};
	
	
	/**
	 * 取得讀取的目標
	 */
	function _getTarget(){
		return eval(target);
	}
	
	/**
	 * 設定讀取目標
	 */
	function _setTarget(s){
		target = s;
	}
	
	/**
	 * 將暫存檔的資料轉移至目前作用的檔案
	 */
	function _replaceNew(){
		voluns = tmpVoluns.slice(0);
		_restore();
	}

	/**
	 * 將暫存檔的資料轉移至目前作用的檔案
	 */
	function _mergeNew(){
		voluns = voluns.concat(tmpVoluns.slice(0));
		_restore();
	}
	
	/**
	 * 回復狀態:清除暫存檔
	 */
	function _restore(){
		tmpVoluns = [];
		_setTarget("voluns");
	}
	this.clickcount = function( num ){		
		
		 var nowcount=parseInt(getCookie('b'+num))+1;	
		 var cur_time = new Date();
	     var expires = cur_time.getTime() + 86400000*7;	  
	     cur_time.setTime(expires);  	    
    	 document.cookie = "b"+num+"="+nowcount+";expires="+cur_time.toGMTString()+";domain="+domain+";path=/";     
	};
	this.doublesave_check = function(Dsave_num){
		if(window.ifdoublesave==true){
			alert("E"+Dsave_num+"-您先前已完成登記志願，系統無法重覆登記志願，操作無法執行。");
						
			//非IE11瀏覽器才使用window.location.href，不然會有另開一視窗效果										
			if(navigator.language){			
				var isIE11=(((navigator.userAgent).indexOf('Trident')!=-1)?'Y':'N');
				var isIE=((navigator.userAgent).indexOf('MSIE')!=-1 )?'Y':'N';
				if(isIE11=='Y'||isIE =='Y'){												
					var xwidth = window.screen.width;
					var xheight = window.screen.height;
					var rf = "<iframe src='main.php?t=xxx' style='border:0px;width:"+xwidth+"px;height:"+xheight+"px;margin:0px;'></iframe>";
					document.write(rf);											
				}else{																	
					window.location.href = 'main.php';												
				}											
			} else {											
				var xwidth = window.screen.width;
				var xheight = window.screen.height;
				var rf = "<iframe src='main.php?t=xxx' style='border:0px;width:"+xwidth+"px;height:"+xheight+"px;margin:0px;'></iframe>";
				document.write(rf);
			}
		}
		window.savenum=1;
	};
	/**
	 * 依校系選志願->點選下面的志願
	 */
	this.bindAddOneVolun = function(){
		//新增校系
		$('.addOne').unbind();
		$('.addOne').click(function(){
			//新增一筆校系
			var canID = $(this).attr('name');
			var result = volunTab.addOne(canID);
			
			if(!result){
				alert(volunTab.getErrorMessage());
			} else {
				
				var info = volunTab.getCanInfo(canID);
				var idx = volunTab.get(canID) - -1;
				$('#addMsg').empty();
				$('#addMsg').text("您已完成加入"+info[2]+'-'+info[3]+"至第"+idx+"志願序");
				$('#addMsg').fadeIn('slow');
				$('#addMsg').fadeOut('slow');
				window.ifadd=true;				
				volunTab.unlock();
				volunTab.render();
			}
			return false;
		});		
	};
	
	//初始化
	this.init = function(){
		//alert('請輸入「基本資料」、「考試分數」與「術科分數」');
		
		//設定志願選擇按鈕
		$("button","#layer1").button({ icons: {primary:'ui-icon-lightbulb'} });
		$("button","#nav").button();
		$('#main').tabs();
		$('.proceed').button();
		$('.trash').button({ icons: {primary:'ui-icon-trash'} });
		$('#saveVol').button({ icons: {primary:'ui-icon-disk'} });
	    $("input","#layer3").button(); //貼上志願碼 button

		//106年度新增
	    if(version != 'web'){
			alert('單機版僅提供個人練習使用，請務必於' + syear + '/8/1 9:00~' + syear + '/8/4 16:30至網路登記分發志願系統完成登記，始可參與分發。');
	    }	    
		/***************************************************
		 *              initial單機版成績 / 基本資料
		 ***************************************************/
		if(version != 'web'){
			//性別
			var isFemale = $('#sex2').attr('checked')?true:false;
			sex = (isFemale)?2:1;
			
			//特種生加分比例
			favor = $('#id_desclist').val();
			
			var isexpert = $('#expert').attr('checked')?true:false;
			expert =(isexpert)?2:1;
		
					
		}
		
		//initial 學測成績輸入0425
	    $('#c_sco input').each(function(i) {
	        var totCscore = 0;
	        var v = $(this).val() - 0;
	        var sid = $(this).attr('id').replace('basic','');

	        //檢查輸入值是否為number
	        if(isNaN(v) || !v){ $(this).val('0'); v=0;}

	        for(var i = 0;i < 6; i++){
	            totCscore += $('#basic'+i).val() - 0;

	            //set score
	            score.cScore[i] = $('#basic'+i).val() - 0;
	        }
	        $('#basic6').val(totCscore);
	    	score.cScore[6] = totCscore;
	    });

		//initial 分科測驗成績輸入
		$('#s_sco input').each(function(i) {
	        //
	        var entryType = $(this).attr('type');
	        var sid = $(this).attr('id').match('exam([0-9]{1,})');

	        switch(entryType){
	            case 'checkbox':
	                var checked = $(this).attr('checked');
	                var idx = sid[1];

	                if(checked){
	                    //enable text input
	                    $('#'+sid[0]+'_score').removeAttr('disabled');
	                    var s = $('#'+sid[0]+'_score').val();

	                    //set score = 0
	                    score.sScore[idx] = (s - 0);
	                    examCount = (examCount | Math.pow(2,idx));
	                } else {
	                    //disable text input
	                    $('#'+sid[0]+'_score').attr('disabled','disabled');

	                    //remove score
	                    $('#'+sid[0]+'_score').val('0');
	                    score.sScore[idx] = undefined;
	                    examCount = (examCount & ~(Math.pow(2,idx)));
	                }
	                break;
	            case 'text':
	            default:
	                break;
	        }
		});
		
		//initial 術科成績輸入
		$('#t_sco input').each(function(i){
			var entryType = $(this).attr('type');
			var sid = $(this).attr('id').match('([a-z]{1,})([0-9]{0,})');

			switch(entryType){
				case 'checkbox':

					var checked = $(this).attr('checked');

					if(checked){
						//enable text input
						$('#'+sid[0]+'_score').removeAttr('disabled');
						var s = $('#'+sid[0]+'_score').val();

						//set score = 0
						var idx = sid[2];
						var skill_index = eval('STRING_TABLE_SKILL.'+sid[1]);
						score.tScore[skill_index][idx] = (s - 0);
						examCount = (examCount | Math.pow(2,skill_index+10));
					} else {
						//disable text input
						$('#'+sid[0]+'_score').attr('disabled','disabled');

						//remove score
						$('#'+sid[0]+'_score').val('0');
						var idx = sid[2];
						var skill_index = eval('STRING_TABLE_SKILL.'+sid[1]);
						score.tScore[skill_index][idx] = undefined;

						//remove exam count
						var cnt = 0;
						for(var i in score.tScore[skill_index]){
							if(score.tScore[skill_index][i] >= 0){
								cnt++;
							}
						}

						if(cnt == 0){
							examCount = (examCount & ~(Math.pow(2,skill_index+10)));
						}
					}
					break;
				case 'text':
				default:
					break;
			}
		});
		
		var counterSubject = this.numberOfselected();
		//2022.06.02 新增非網路版才要判斷科目限制 Lydia
		if(counterSubject < 3 && (version != 'web')){ 
			alert("請輸入「基本資料」、「考試分數」與「術科分數」");
		}
		
		//讀取cookie的志願資料
		var cookie = getCookie('Vol');
		if(cookie.length > 0){
			this.batchAdd(cookie);
			$("#main").tabs( "option", "disabled", [] );
			
			//已選取100個志願
			if(cookie.length >= 400){
				this.lock_choice_menu();
			}
		} else {
			//沒有志願，關閉完成選填志願
			lock_finlock();
		}
		
		/************************************************
		 *             關閉暫存志願
		 ***********************************************/
		lock_savevol();
		
		//讀取學校資料
		
		$('#filter_school').append("<option value='' selected>不設條件</option>");
		$('#list_school').append("<option value='' selected disabled>--請選擇學校--</option>");
	
		var school_key=[];
		for(var i in school_array){
			school_key.push(i);
		}
		school_key.sort();	
		for(var j in school_key){
			var i = school_key[j];		
				$('#filter_school').append('<option value="'+i+'">['+i+']'+school_array[i]+'</option>');
				$('#list_school').append('<option value="'+i+'">['+i+']'+school_array[i]+'</option>');			
		}
		
		//點選
		this.bindAddOneVolun();
		
		//顯示校系代碼檔
		$('#div_list_dept').find('dl').html("<div class='ctx'>請點選選單,選擇學校</div>");		
		
		$('#filter_gcd').append("<option value='' selected>不設條件</option>");
		
		//讀取學群資料
		var gm_key = [];
		for(var i in gm_array){
			gm_key.push(i);
		}
		gm_key.sort();
		
		for(var j in gm_key){
			var i = gm_key[j];
			$('#filter_gcd').append('<option value="'+i+'">'+gm_array[i].gname+'</option>');
		}
		$('#filter_gcd').change(function(){
			var gcd = $(this).val();
			
			$('#filter_mcd').html("<option value='' selected>不設條件</option>");
			if(gm_array[gcd] !== undefined){
				for(var i in gm_array[gcd].entry){
				    var mcd = gm_array[gcd].entry[i][0];
				    var mNa = gm_array[gcd].entry[i][1];
				    $('#filter_mcd').append('<option value="'+mcd+'">'+mNa+'</option>');
				}
			}
		});
		
		//讀取學類資料
		$('#filter_mcd').append("<option value='' selected>不設條件</option>");
		
		//建立依條件選志願的過濾條件
		this.createFilter();
		
		//輸出
		this.render();
	};
	
	/**************************************************
	 *           判斷分科測驗+術科是不是大於3科
	 *************************************************/
	this.numberOfselected = function(){
		
		var counterSubject = 0;
		
		//分科測驗
		for(var i in score.sScore){
			if(!isNaN(score.sScore[i])) counterSubject++;
		}
		
		//術科
		var tested = 0;
		for(var i in score.tScore){
			for(var j in score.tScore[i]){
				if(!isNaN(score.tScore[i][j])) tested++;
			}
		}
		if(tested > 0) counterSubject++;
		
		return counterSubject;
	};
	
	//儲存志願
	this.save = function(){
		//暫存志願,設上一年的過期時間
        var cur_time = new Date();
        var expires = cur_time.getTime() + 86400000*7;
        cur_time.setTime(expires);
        if(version == 'web'){
        	document.cookie = "Vol="+this.serialize()+";expires="+cur_time.toGMTString()+";domain="+domain+";path=/";
        	       	
        } else {
            document.cookie = "Vol="+this.serialize()+";expires="+cur_time.toGMTString();
        }
	};
	
	//刪除cookie
	this.clean = function(){
		var cur_time = new Date();
		var expires = cur_time.getTime() - 86400000;
		cur_time.setTime(expires);
		document.cookie = "Vol=;expires="+cur_time.toGMTString();
	};
	
	//清除志願
	this.clear = function(){
		voluns = [];
		this.unlock_choice_menu();
	};
	
	//取得校系資料
	this.getCanInfo = function(canid){
		//若在停招校系清單中，就回傳null-1090703 kilala modify
		if ($.inArray(canid, del_dept_array) != -1) return null;
		
		//計算index
		var estIdx = (parseInt(canid,8) - 1);

		//檢查該row是否為此canid,如果不是,計算gap值重新fetch
		try{
			//index最大值正常狀況下會比校系陣列數少1，若出現index大於等於校系陣列數時，表示前面有校系刪掉了，所以從最後一個校系往前找-1090703kilala modify
			if(estIdx >= dept_array.length){
				var j;
				for(j=dept_array.length-1;j>0;j--){
					var nCanId = dept_array[j][CAN_ID];
					if(nCanId == canid) return dept_array[j];
				}
				return null;
			}else{
				var gCanId = dept_array[estIdx][CAN_ID];
				if(gCanId == canid) return dept_array[estIdx];
				/*var gap = parseInt(canid,8) - parseInt(gCanId,8) ; //計算與原本的位置差距多少-1090703kilala modify
				//往前縮減中間若又被有被刪掉的校系，這樣會導致往前找的校系起始位置太前面，所以要找出canid跟gCanId中間有多少校系被刪掉，再把gap值加回來
				var filteredNum = del_dept_array.filter(function(value) {
				   return (parseInt(gCanId) > parseInt(value) && parseInt(value) > parseInt(canid));
				});
				gap = gap + filteredNum.length;*/
				gap = -1;
				//var gap = (estIdx - parseInt(gCanId,8) + 1); //通常都是中間有少index,所以estimate都會比較大gCanId > estIdx
				//while(gap != 0){ 
				while(estIdx+gap >= 0){
					var nxIdx = (estIdx + gap);  
					var nCanId = dept_array[nxIdx][CAN_ID];
					if(nCanId == canid) return dept_array[nxIdx];
					//gap = (estIdx - parseInt(nCanId,8) - 1);
					gap--;//若縮減原本的差距值(gap)還是找不到，就把gap減1，繼續往前找-1090703kilala modify
				}	
				return null;				
			}
		}catch(e){
			return null;
		}
	};
	
	//交換志願
	this.exchange = function(from,to){
		//沒有動作則不交換
		if(from == to) return;
		
		var buffer = [];
		var canID = voluns[from];
		for (var i in voluns){
			if(i == from){
				continue;
			} else if (i == to){
				if(from > to){
					buffer.push(canID);
					buffer.push(voluns[i]);
				} else {
					buffer.push(voluns[i]);
					buffer.push(canID);
				}
			} else {
				buffer.push(voluns[i]);
			}
		}
		$("#saveVol").button( "enable");
		voluns = buffer.slice(0);
	};
	
	this.count = function(){
		return voluns.length;
	},
	
	//清除錯誤訊息
	this.clearError = function(){
		for(var i in err){
			err[i] = undefined;
		}
		return this;
	};
	
	this.onlyQuataZeroError = function(){
		var counter      = 0;
		var hasZeroQuota = 0;
		for(var i in err){
			if(err[i] === undefined) continue;
			counter++;
			if(i == '-5'){
				hasZeroQuota = 1;
			}
		}
		
		if(counter != 1) return false;
		if(hasZeroQuota != 1) return false;
		return true;
	};
	
	//取得錯誤訊息
	this.getErrorMessage = function(){
		var out = '';
		for(var i in err){
			if(err[i] === undefined) continue;
			var msg = err[i];
			if(msg.length > 0){
				out += "\n"+errCode[i]+"："+err[i];
			} else {
				out += "\n"+errCode[i]; 
			}
		}
		return out;
	};
	
	return this;
};
